Package org.apache.sis.metadata.iso.constraint

# Class DefaultLegalConstraints

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultConstraints
DefaultLegalConstraints

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Constraints`, `LegalConstraints`

public class DefaultLegalConstraints extends DefaultConstraints implements LegalConstraints
Restrictions and legal prerequisites for accessing and using the resource. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
`MD_LegalConstraints` `├─accessConstraints……` Access constraints applied to assure the protection of privacy or intellectual property. `├─useConstraints……………` Constraints applied to assure the protection of privacy or intellectual property. `└─otherConstraints………` Other restrictions and legal prerequisites for accessing and using the resource.
The other constraints collection shall be non-empty if access constraints and/or use constraints elements have a value of `Restriction​.OTHER_RESTRICTIONS`.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultLegalConstraints()`
  Constructs an initially empty constraints.
  `DefaultLegalConstraints(CharSequence useLimitation)`
  Constructs a new constraints with the given use limitation.
  `DefaultLegalConstraints(LegalConstraints object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultLegalConstraints`
  `castOrCopy(LegalConstraints object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Collection<Restriction>`
  `getAccessConstraints()`
  Returns the access constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations on obtaining the resource.
  `Collection<InternationalString>`
  `getOtherConstraints()`
  Returns the other restrictions and legal prerequisites for accessing and using the resource.
  `Collection<Restriction>`
  `getUseConstraints()`
  Returns the constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations or warnings on using the resource.
  `void`
  `setAccessConstraints(Collection<? extends Restriction> newValues)`
  Sets the access constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations on obtaining the resource.
  `void`
  `setOtherConstraints(Collection<? extends InternationalString> newValues)`
  Sets the other restrictions and legal prerequisites for accessing and using the resource.
  `void`
  `setUseConstraints(Collection<? extends Restriction> newValues)`
  Sets the constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations or warnings on using the resource.

  ### Methods inherited from class DefaultConstraints

  `castOrCopy, getConstraintApplicationScope, getGraphics, getReferences, getReleasability, getResponsibleParties, getUseLimitations, setConstraintApplicationScope, setGraphics, setReferences, setReleasability, setResponsibleParties, setUseLimitations`

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Constraints

  `getUseLimitations`

- ## Constructor Details

  - ### DefaultLegalConstraints

    public DefaultLegalConstraints()
    Constructs an initially empty constraints.

  - ### DefaultLegalConstraints

    public DefaultLegalConstraints(CharSequence useLimitation)
    Constructs a new constraints with the given use limitation.
    Parameters:
      `useLimitation` - the use limitation, or `null` if none.

  - ### DefaultLegalConstraints

    public DefaultLegalConstraints(LegalConstraints object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(LegalConstraints)`

- ## Method Details

  - ### castOrCopy

    public static DefaultLegalConstraints castOrCopy(LegalConstraints object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultLegalConstraints`, then it is returned unchanged.
    - Otherwise a new `DefaultLegalConstraints` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getAccessConstraints

    public Collection<Restriction> getAccessConstraints()
    Returns the access constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations on obtaining the resource.
    Specified by:
      `getAccessConstraints` in interface `LegalConstraints`
    Returns:
      access constraints applied to assure the protection of privacy or intellectual property.

  - ### setAccessConstraints

    public void setAccessConstraints(Collection<? extends Restriction> newValues)
    Sets the access constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations on obtaining the resource.
    Parameters:
      `newValues` - the new access constraints.

  - ### getUseConstraints

    public Collection<Restriction> getUseConstraints()
    Returns the constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations or warnings on using the resource.
    Specified by:
      `getUseConstraints` in interface `LegalConstraints`
    Returns:
      constraints applied to assure the protection of privacy or intellectual property.

  - ### setUseConstraints

    public void setUseConstraints(Collection<? extends Restriction> newValues)
    Sets the constraints applied to assure the protection of privacy or intellectual property, and any special restrictions or limitations or warnings on using the resource.
    Parameters:
      `newValues` - the new use constraints.

  - ### getOtherConstraints

    public Collection<InternationalString> getOtherConstraints()
    Returns the other restrictions and legal prerequisites for accessing and using the resource. Shall be a non-empty value only if access constraints or use constraints declares other restrictions.
    Specified by:
      `getOtherConstraints` in interface `LegalConstraints`
    Returns:
      other restrictions and legal prerequisites for accessing and using the resource.

  - ### setOtherConstraints

    public void setOtherConstraints(Collection<? extends InternationalString> newValues)
    Sets the other restrictions and legal prerequisites for accessing and using the resource.
    Parameters:
      `newValues` - Other constraints.